diff a/src/hotspot/cpu/riscv/compressedKlass_riscv.cpp b/src/hotspot/cpu/riscv/compressedKlass_riscv.cpp
--- a/src/hotspot/cpu/riscv/compressedKlass_riscv.cpp
+++ b/src/hotspot/cpu/riscv/compressedKlass_riscv.cpp
@@ -54,13 +54,13 @@
   // Failing that, attempt to reserve for base=zero shift>0
   if (result == nullptr && optimize_for_zero_base) {
     result = reserve_address_space_for_zerobased_encoding(size, aslr);
   }
 
-  // Failing that, optimize for case (3) - a base with only bits set between [33-44)
+  // Failing that, optimize for case (3) - a base with only bits set between [32-44)
   if (result == nullptr) {
-    const uintptr_t from = nth_bit(32 + (optimize_for_zero_base ? LogKlassAlignmentInBytes : 0));
+    const uintptr_t from = nth_bit(32);
     constexpr uintptr_t to = nth_bit(44);
     constexpr size_t alignment = nth_bit(32);
     result = reserve_address_space_X(from, to, size, alignment, aslr);
   }
 
@@ -72,5 +72,7 @@
     result = reserve_address_space_X(from, to, size, alignment, aslr);
   }
 
   return result;
 }
+
+bool CompressedKlassPointers::pd_initialize(address addr, size_t len) { return false; }
